"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readFromDisk = exports.writeToDisk = void 0;
const fs_1 = require("fs");
const path_1 = require("path");
const write_file_atomic_1 = require("write-file-atomic");
const writeToDisk = (dirPath, filename, payload) => {
    const filePath = (0, path_1.join)(dirPath, filename);
    (0, fs_1.mkdirSync)(dirPath, { recursive: true, mode: parseInt('0700', 8) });
    (0, write_file_atomic_1.sync)(filePath, payload, { mode: parseInt('0600', 8) });
};
exports.writeToDisk = writeToDisk;
const readFromDisk = (dirPath, filename) => {
    const filePath = (0, path_1.join)(dirPath, filename);
    return (0, fs_1.readFileSync)(filePath, 'utf8');
};
exports.readFromDisk = readFromDisk;
