"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOptions = void 0;
const crypto_1 = require("./crypto");
const reducer_1 = require("./reducer");
const system_1 = require("./system");
function getOptions(_a) {
    var { name } = _a, overrides = __rest(_a, ["name"]);
    const { encoder, decoder } = (0, crypto_1.getDefaultCrypto)();
    return Object.assign({ name, defaults: {}, filename: 'config.pref', dirPath: (0, system_1.getSystemConfigPath)(name, process.platform, process.env.XDG_CONFIG_HOME), serializer: JSON.stringify, deserializer: JSON.parse, encoder,
        decoder,
        setter: reducer_1.setter,
        getter: reducer_1.getter,
        equality: reducer_1.equality }, overrides);
}
exports.getOptions = getOptions;
