"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSystemConfigPath = void 0;
const os_1 = require("os");
const path_1 = require("path");
const getMacOSConfigPath = (name) => {
    return (0, path_1.join)((0, os_1.homedir)(), 'Library', 'Preferences', name);
};
const getWindowsConfigPath = (name) => {
    return (0, path_1.join)((0, os_1.homedir)(), 'AppData', 'Roaming', name, 'Config');
};
const getLinuxConfigPath = (name, path) => {
    if (path) {
        return (0, path_1.join)(path, name);
    }
    return (0, path_1.join)((0, os_1.homedir)(), '.config', name);
};
const getSystemConfigPath = (name, platform, xdgConfigHome) => {
    if (platform === 'darwin') {
        return getMacOSConfigPath(name);
    }
    if (platform === 'win32') {
        return getWindowsConfigPath(name);
    }
    return getLinuxConfigPath(name, xdgConfigHome);
};
exports.getSystemConfigPath = getSystemConfigPath;
