"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPackageData = exports.shouldWrite = exports.normalizeId = exports.pad = void 0;
const mem = require("mem");
const pkgUp = require("pkg-up");
const pad = (text, padding) => text.padEnd(32, padding).slice(0, 32);
exports.pad = pad;
const normalizeId = (id) => id
    .replace(/[^a-zA-Z0-9-_]+/g, '.')
    .replace(/\.+/g, '.')
    .replace(/\.$|\.pref$/g, '');
exports.normalizeId = normalizeId;
const shouldWrite = (equality, state, newState) => (typeof equality === 'function' ? !equality(state, newState) : equality);
exports.shouldWrite = shouldWrite;
exports.getPackageData = mem((cwd) => {
    const packagePath = pkgUp.sync({ cwd });
    const packageData = require(packagePath);
    return packageData || {};
});
